<script setup lang="ts">
import {
  AiRootCauseAnalysis,
  AiGitlabChat,
  AiCodeSuggestions,
  AiVulnerabilityBug,
  AiValueStreamForecast,
} from 'slippers-ui/icons';

interface TextAndVideoCol {
  video: {
    thumbnail: string;
    videoMP4: string;
    videoWebm: string;
  };
  textBlock: {
    header: string;
    text: string;
    eyebrow?: {
      text: string;
      config?: {
        icon: string;
      };
    };
  };
  config: { theme?: string; reverse?: boolean };
  index: number;
}

const icons: Component = {
  AiRootCauseAnalysis,
  AiGitlabChat,
  AiCodeSuggestions,
  AiVulnerabilityBug,
  AiValueStreamForecast,
};

defineProps<TextAndVideoCol>();
</script>

<template>
  <section class="text-and-video-col" :class="`text-and-video-col--${config?.theme}`">
    <SlpRow
      class="text-and-video-col__row"
      :class="`text-and-video-col__row--${config?.reverse === true ? 'reverse' : ''}`"
    >
      <SlpColumn :cols="6">
        <div class="text-and-video-col__eyebrow">
          <SlpIcon
            v-if="textBlock.eyebrow?.config?.icon"
            :icon="icons[textBlock.eyebrow?.config?.icon]"
            class="slp-mr-8"
          />
          <SlpTypography variant="body2-bold" tag="span">
            {{ textBlock.eyebrow?.text }}
          </SlpTypography>
        </div>
        <SlpTypography class="slp-pb-16" variant="heading3-bold" tag="h2">
          {{ textBlock.header }}
        </SlpTypography>
        <SlpTypography variant="body1" tag="p" class="text-and-video-col__text">
          {{ textBlock.text }}
        </SlpTypography>
      </SlpColumn>
      <SlpColumn :cols="6">
        <div v-if="video" class="text-and-video-col__video-card">
          <div ref="videoRef" class="text-and-video-col__video-card__inner" :data-index="index">
            <video
              ref="videoElement"
              class="text-and-video-col__video-looping"
              loop
              muted
              playsinline
              autoplay="isPlaying"
              :poster="video.thumbnail"
            >
              <source :src="video?.videoMP4" type="video/mp4" />
              <source :src="video?.videoWebm" type="video/webm" />
            </video>
          </div>
        </div>
      </SlpColumn>
    </SlpRow>
  </section>
</template>

<style lang="scss" scoped>
.text-and-video-col {
  padding: 80px 0;
  &__video-card {
    max-width: 100%;
    border-radius: 8px 8px 120px 8px;
    border: 1px solid $color-surface-600;
    overflow: hidden;
    height: 350px;

    img {
      height: 100%;
    }
    @media (max-width: $breakpoint-md) {
      margin-top: $spacing-48;
      height: 200px;
    }
    &__inner {
      position: relative;
      height: 100%;

      img {
        width: 100%;
        cursor: pointer;
        display: block;
        transition: all 0.2s ease;
      }
    }
  }
  &__video-looping {
    height: 100%;
  }
  &__row {
    align-items: center;
    &--reverse {
      flex-direction: row-reverse;
      .text-and-video-col__video-card {
        max-width: 100%;
        border-radius: 8px 8px 8px 120px;
      }
    }
  }
  &__eyebrow {
    margin-bottom: 16px;
    position: relative;
    padding: 4px 12px;
    display: inline-flex;
    align-items: center;

    &:before {
      content: '';
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      border-radius: 20px;
      border: 1.5px solid transparent;
      background: linear-gradient(89.09deg, #e1986d -1.12%, #7759c2 102.06%, #6e43d3 102.07%) border-box;
      -webkit-mask:
        linear-gradient(#fff 0, #fff 0) padding-box,
        linear-gradient(#fff 0, #fff 0);
      -webkit-mask:
        linear-gradient(#fff 0 0) padding-box,
        linear-gradient(#fff 0 0);
      -webkit-mask-composite: xor;
      mask-composite: exclude;
    }
    .slp-icon {
      height: 20px;
      width: 20px;
    }
  }
  &__text {
    color: $color-surface-400;
  }
  &--dark {
    color: $color-text-50;
  }
  .slp-col-md-6 {
    padding: 0 24px;
  }
}
</style>
